#ifndef GREEN_H
#define GREEN_H 1
#include <fftw3.h>


using namespace std;

#ifndef PI
#define PI 3.1415926535
#endif

namespace SEPMY {
void green1D(float *greenRe, float *greenIm, float k, float x0, float *y, int n);
void green2D(float *greenRe, float *greenIm, float k, float x0, float *y, int n);
void green3D(float *greenRe, float *greenIm, float k, float x0, float *y, int n);

void fftHarmonic(float *timeRe, float *timeIm, float *freqRe, float *freqIm, int nt);
void ifftHarmonic(float *timeRe, float *timeIm, float *freqRe, float *freqIm, int nt);

void green1D(float *greenRe, float *greenIm, float k, float x0, float *y, int n) {

}
void green2D(float *greenRe, float *greenIm, float k, float x0, float *y, int n) {

}
void green3D(float *greenRe, float *greenIm, float k, float x0, float *y, int n) {

}

void fftHarmonic(float *timeRe, float *timeIm, float *freqRe, float *freqIm, int N) {
	double scale = 1./sqrt(1.*N);
	fftw_complex freqComp[N];
	fftw_complex timeComp[N];
    for (int i = 0; i < N; i++) {
    	timeComp[i][0] = timeRe[i];
    	timeComp[i][1] = timeIm[i];
    }
    fftw_plan forward;
    forward = fftw_plan_dft_1d(N, timeComp, freqComp, FFTW_FORWARD, FFTW_ESTIMATE);
    fftw_execute (forward);
    for (int i = 0; i < N; i++) {
    	freqRe[i] = freqComp[i][0] * scale;
    	freqIm[i] = freqComp[i][1] * scale;
    }
}

void ifftHarmonic(float *timeRe, float *timeIm, float *freqRe, float *freqIm, int N) {
	double scale = 1./sqrt(1.*N);
	fftw_complex freqComp[N];
	fftw_complex timeComp[N];
    for (int i = 0; i < N; i++) {
    	freqComp[i][0] = freqRe[i];
    	freqComp[i][1] = freqIm[i];
    }
    fftw_plan backward;
    backward = fftw_plan_dft_1d(N,freqComp, timeComp, FFTW_BACKWARD, FFTW_ESTIMATE);
    fftw_execute (backward);
    for (int i = 0; i < N; i++) {
    	timeRe[i] = timeComp[i][0] * scale;
    	timeIm[i] = timeComp[i][1] * scale;
    }
}



}

#endif
