#ifndef RANDOM2ND_H
#define RANDOM2ND_H 1
#include <fftw3.h>


using namespace std;

#ifndef PI
#define PI 3.1415926535
#endif

namespace SEPMY {
void Random2nd(float * model, int nx, int nz, int size, int pad) {

	for (int ix = 0; ix < nx; ix = ix + size) {
		for (int iz = 0; iz < nz; iz = iz + size) {
			if (iz > pad && iz < nz - pad && ix > pad && ix < nx - pad) continue;
			model[ix * nz + iz] += (1.0 * rand()) / RAND_MAX - 0.5;
		}
	}

	for (int ix = 0; ix < nx; ix++) {
		for (int iz = 0; iz < nz; iz++) {
			if (iz > pad && iz < nz - pad && ix > pad && ix < nx - pad) continue;
			int px = (1.0 * rand() / RAND_MAX) * size;
			int pz = (1.0 * rand() / RAND_MAX) * size;
			if (px > ix % size && pz > iz % size) {
				model[ix * nz + iz] = model[(ix / size) * size * nz + (iz / size) * size];
			} else if (px < ix % size && pz > iz % size) {
				model[ix * nz + iz] = model[((ix / size) + 1) * size * nz + (iz / size) * size];
			} else if (px > ix % size && pz < iz % size) {
				model[ix * nz + iz] = model[((ix / size) + 0) * size * nz + ((iz / size) + 1) * size];
			} else {
				model[ix * nz + iz] = model[((ix / size) + 1) * size * nz + ((iz / size) + 1) * size];
			}
		}
	}
}

}

#endif
