#include "SEPMYinc.h"
#include "Vector.h"
#include "utilGENESIS.h"
#include "PropVTI2dGPU.cu"

using namespace std;
using namespace SEPMY;

/*
 *  code to generate RTM 2d image for GENESIS dataset with extended offset.
 *  VTI wave equation is applied on GPU
 *
 *  Input:
 *  	seed: int, used to shuffle shot gather, for quick debugging
 *  	offmin: float, minimum offset used for RTM
 *  	offmax: float, maximum offset used for RTM
 *
 *  Output:
 *
 *  Author: Yinbin Ma
 *  First created: 2018-01-23
 *  Last modified: 2018-01-23
 */

int main (int argc, char *argv[]) {
	initpar(argc, argv);
	int nt = 2000, noff1 = 175, noff2 = 280, noff = noff1 + noff2, nm = 1000;
	float *d1 = new float[nt * noff1 * nm];
	float *d2 = new float[nt * noff2 * nm];
	float *d  = new float[nt * noff  * nm];
	sreed("data1", d1, sizeof(float) * nt * noff1 * nm);
	sreed("data2", d2, sizeof(float) * nt * noff2 * nm);
	for (int i3 = 0; i3 < nm; i3++) {
		for (int ioff = 0; ioff < noff1; ioff++) {
			for (int it = 0; it < nt; it++) {
				d[i3 * noff * nt + ioff * nt + it] = d1[i3 * noff1 * nt + (noff1 - 1 - ioff) * nt + it];
			}
		}
		for (int ioff = 0; ioff < noff2; ioff++) {
			for (int it = 0; it < nt; it++) {
				d[i3 * noff * nt + (ioff + noff1) * nt + it] = 3 * d2[i3 * noff2 * nt + ioff * nt + it];
			}
		}
	}
	srite("data", d, sizeof(float) * nt * noff  * nm);
	return 0;
}
