#include "SEPMYinc.h"
#include "Vector.h"
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
using namespace std;
using namespace SEPMY;

/*
 *  code to compare analytical solution and numerical solution
 *
 *  Input:
 *
 *  Output:
 *
 *  Author: Yinbin Ma
 *  First created: 2018-02-06
 *  Last Modified: 2018-02-06
 */

int main (int argc, char *argv[]) {
	initpar(argc, argv);
	cout << "========== Checking headers ==========" << endl;
	//set up propagation par
	int nt = 2000, noff = 30, nmid = 1264;
	float *d1 = new float[nt * noff * nmid];
	float *d2 = new float[nt * noff * nmid];
	sreed("d1", d1, sizeof(float) * nt * noff * nmid);
	sreed("d2", d2, sizeof(float) * nt * noff * nmid);
	float *dat = new float[nt * (noff * 2 + 1) * nmid];
	float scale = 3;
	for (int i = 0; i < nmid; i++) {
		for (int j = 0; j < noff; j++) {
			int k = 2 * noff - j;
			for (int t = 0; t < nt; t++) {
				dat[i * (noff * 2 + 1) * nt + j * nt + t] = d1[i * noff * nt + (noff - j - 1) * nt + t];
				dat[i * (noff * 2 + 1) * nt + k * nt + t] = d2[i * noff * nt + (noff - j - 1) * nt + t] * scale;
			}
		}
		for (int t = 0; t < nt; t++)
			dat[i * (noff * 2 + 1) * nt + noff * nt + t] = 1000;
	}
	srite("dout", dat, sizeof(float) * nt * (noff * 2 + 1) * nmid);
	return 0;
}


