#include "SEPMYinc.h"
#include "Vector.h"

using namespace std;
using namespace SEPMY;
/*
 *  Co process 6 geometry at the same time
 *
 */

int main(int argc, char *argv[]) {
	initpar(argc, argv);

	// define the map
	int n2 = 1303, n1 = 280;
	float *map = new float[n1 * n2];
	sreed("map", map, sizeof(float) * n1 * n2);
	float m0 = 10055108; // mid point, x % 41 == 23

	// extract shift, geometry
	int shift, ntrace, noff;
	float x0, dx, off0, doff;
	int isShotGather = 0, gapOn = 0;
	getch("shift", "d", &shift);                //cout << shift << endl;
	getch("ntrace", "d", &ntrace);              //cout << ntrace << endl;
	getch("noff", "d", &noff);                  //cout << noff << endl;
	getch("x0", "f", &x0);                      //cout << x0 << endl;
	getch("dx", "f", &dx);                      //cout << dx << endl;
	getch("off0", "f", &off0);                  //cout << off0 << endl;
	getch("doff", "f", &doff);                  //cout << doff << endl;
	getch("isShotGather", "d", &isShotGather);  //cout << isShotGather << endl;
	getch("gapOn", "d", &gapOn);
	int sign = 1;
	if (isShotGather == 1) sign = -1;

	// fill header
	float *head = new float[ntrace * noff * 7];
	float *headGap = new float[ntrace * noff * 7];
	float *test = new float[ntrace * noff];
	cout << " start from  " << x0 + shift * dx << endl;
	for (int itrace = 0; itrace < ntrace; itrace++) {
		float x = x0 + (itrace + shift) * dx;
		for (int ioff = 0; ioff < noff; ioff++) {
			float off = off0 + ioff * doff;
			float y = x + off;
			if (isShotGather) {
				off = off0 + (noff - ioff - 1) * doff;
				y = x - off;
			}
			float s = max(x, y);
			float r = min(x, y);
			float m = (x + y) / 2.0;
			int id = itrace * noff + ioff;
			head[7 * id + 0] = x * 0.3048;   // sx, or rx
			head[7 * id + 1] = 0.0; // y, no use now
			head[7 * id + 2] = 0.0;
			head[7 * id + 3] = y * 0.3048;
			head[7 * id + 4] = 0.0;
			head[7 * id + 5] = 0.0;
			head[7 * id + 6] = 1.0;
			headGap[7 * id + 0] = x * 0.3048;   // sx, or rx
			headGap[7 * id + 1] = 0.0; // y, no use now
			headGap[7 * id + 2] = 0.0;
			headGap[7 * id + 3] = y * 0.3048;
			headGap[7 * id + 4] = 0.0;
			headGap[7 * id + 5] = 0.0;
			headGap[7 * id + 6] = 1.0;
			test[id] = 1.0;
			int id2 = (m - m0)/ 41;
			int id1 = ioff;
			if (id2 < 0 || id2 >= n2) continue;
			if (map[id2 * n1 + id1] < 0.5) {
				//cout << "find one" << endl;
				headGap[7 * id + 6] = 0.0;
				test[id] = 0.0;
			}
//			if (gapOn && SRC0 < s && s < SRC1 && REC0 < r && r < REC1) {
//				head[7 * id + 6] = 0.0;
//				test[id] = 0.0;
//			}
		}
	}

  	axis ax1(7, 0, 1, "numHead", "unitless");
  	axis ax2(noff, 0, 1, "numOffset", "unitless");
  	axis ax3(ntrace, 0, 1, "numTrace", "unitless");
  	vector<axis> axes1{ax1, ax2, ax3};
  	hyperCube cube(axes1);
  	vector<axis> axes2{ax2, ax3};
  	hyperCube cubeT(axes2);
	srite("head", head, sizeof(float) * ntrace * noff * 7);
	cube.writeAxes("head");
	srite("headGap", headGap, sizeof(float) * ntrace * noff * 7);
	cube.writeAxes("headGap");
	srite("test", test, sizeof(float) * ntrace * noff);
	cubeT.writeAxes("test");

	return 0;
}
