#include "SEPMYinc.h"
#include "Vector.h"
#include "utilGENESIS.h"
#include "PropVTI2dGPU.cu"
#include <iostream>       // std::cout, std::endl
#include <thread>         // std::this_thread::sleep_for
#include <chrono>         // std::chrono::seconds

using namespace std;
using namespace SEPMY;

/*
 *  code to generate RTM 2d image for GENESIS dataset with extended offset.
 *  VTI wave equation is applied on GPU
 *
 *  Input:
 *  	seed: int, used to shuffle shot gather, for quick debugging
 *  	offmin: float, minimum offset used for RTM
 *  	offmax: float, maximum offset used for RTM
 *
 *  Output:
 *
 *  Author: Yinbin Ma
 *  First created: 2018-01-23
 *  Last modified: 2018-01-23
 */

int main (int argc, char *argv[]) {
	initpar(argc, argv);

	float *tmp;
	for (int i = 0; i < 8; i++) {
		cudaSetDevice(i);
		for (int j = 0; j < 300; i++) {
			cudaMalloc((void**) &tmp, 1000 * 1000 * sizeof(float));
		}
	}

	std::cout << "countdown:\n";
	for (int i=100; i>0; --i) {
		std::cout << i << std::endl;
	    std::this_thread::sleep_for (std::chrono::seconds(1));
	}
	std::cout << "Lift off!\n";
	return 0;
}
